part of masamune;

@immutable
class LocalModuleAdapter extends ModuleAdapter<LocalDynamicDocumentModel,
    LocalDynamicCollectionModel> {
  const LocalModuleAdapter();

  @override
  ModelProvider<T> collectionProvider<T extends LocalDynamicCollectionModel>(
          String path) =>
      localCollectionProvider(path) as ModelProvider<T>;

  @override
  ModelProvider<T> documentProvider<T extends LocalDynamicDocumentModel>(
          String path) =>
      localDocumentProvider(path) as ModelProvider<T>;

  @override
  T loadDocument<T extends LocalDynamicDocumentModel>(T document) {
    return document..loadOnce();
  }

  @override
  T loadCollection<T extends LocalDynamicCollectionModel>(T collection) {
    return collection..loadOnce();
  }

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool enabledAuth = false;

  @override
  Future<void> registerInEmailAndPassword(
      {required String email, required String password}) {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> sendPasswordResetEmail({required String email}) {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> signInAnonymously() {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> signInEmailAndPassword(
      {required String email, required String password}) {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> signOut() {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> tryRestoreAuth() {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get email {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool isAnonymously = true;

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool isSignedIn = true;

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool isVerified = true;

  @override
  String get name {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get phoneNumber {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get photoURL {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get userId => Config.uid;
}
